import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.ArrayList;
import java.util.Collection;

public class MediaController implements ActionListener, ListSelectionListener {
    MediaView mv = new MediaView(this, this);
    //TODO: Collection fr Fotos einfgen
    Collection<Foto> fotocollection = new ArrayList<>();


    /**
     * Controller - nichts zu tun
     */
    public MediaController() {
        // nichts zu tun
        mv.setPhotoList(getNamesPhoto());
        mv.display();
    }

    /**
     * Aus der Collection mssen alle Namen in ein String[] kopiert werden
     *
     * @return String[] mit allen Namen
     */
    String[] getNamesPhoto() {
        String[] strar = new String[fotocollection.size()];

        int i = 0;
        for (Foto ft: fotocollection) {
             strar[i] = ft.getName();
             i++;
        }

        return strar;
    }

    @Override
    /**
     * Actionlistener - muss ausprogrammiert werden
     */
    public void actionPerformed(ActionEvent e) {
        System.out.println(e.getActionCommand());
        if (e.getActionCommand() == "Laden") {
            JFileChooser chooser = new JFileChooser(new File("."));
            FileNameExtensionFilter filter = new FileNameExtensionFilter("Images", "photo");
            chooser.setFileFilter(filter);
            int returnVal = chooser.showOpenDialog(mv);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName());

                File myfile = new File(chooser.getSelectedFile().getName());
                try {
                    BufferedReader reader = new BufferedReader(new FileReader(myfile));
                    while (reader.ready()) {
                        String line = reader.readLine();
                        String[] spl = line.split(";");

                        if (spl.length != 6)
                            throw new WrongFileFormatException("invaild number of columns");

                        try {
                            Foto ft = new Foto(spl[0],
                                    Integer.parseInt(spl[1]),
                                    Integer.parseInt(spl[2]),
                                    Integer.parseInt(spl[4]),
                                    Integer.parseInt(spl[5]),
                                    spl[3]);

                            fotocollection.add(ft);
                        } catch (NumberFormatException ee) {
                            throw new WrongFileFormatException("parse error- no integer in file column");
                        }
                    }

                } catch (FileNotFoundException fileNotFoundException) {
                    fileNotFoundException.printStackTrace();
                } catch (IOException ioException) {
                    ioException.printStackTrace();
                } catch (WrongFileFormatException en) {
                    System.err.println("an File Format exception occured: "+en.getMessage());
                }

            }
            // TODO: Datei auswhlen und die Daten in die Collection laden
        } else if (e.getActionCommand() == "Grafik") {
            // TODO: die Hufigkeiten der Fotoformate muss berechnet werden
            //    und an die Methode displayGraph bergeben werden

            //	mv.displayGraph(???);
        }

    }

    @Override
    /**
     * ListSelectionListener - wenn sich die
     */
    public void valueChanged(ListSelectionEvent e) {
        // TODO: die Daten zum ausgewhltem Foto mssen mit setData angezeigt werden

        // mv.setData(???);
    }

}
